using Microsoft.UI.Composition;
using Microsoft.UI.Xaml;
using Microsoft.UI.Xaml.Controls;
using Microsoft.UI.Xaml.Input;
using Microsoft.UI.Xaml.Media;

using Windows.Foundation.Metadata;

namespace TestProject
{
    /// <summary>
    ///  
    /// </summary>
    public sealed partial class MainPage : Page
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// ռ
        /// </summary>
        private Compositor compositor = CompositionTarget.GetCompositorForCurrentThread();

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - MainPage()

        /// <summary>
        /// 
        /// </summary>
        public MainPage()
        {
            InitializeComponent();

            this.rectangle.OpacityTransition = new ScalarTransition();

            this.opacityNumberBox.KeyDown += opacityNumberBox_KeyDown;
            this.opacityButton.Click      += opacityButton_Click;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private
        //////////////////////////////////////////////////////////////////////////////// Event

        #region  ѹ ڽ Ű ٿ óϱ - opacityNumberBox_KeyDown(sender, e)

        /// <summary>
        ///  ѹ ڽ Ű ٿ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void opacityNumberBox_KeyDown(object sender, KeyRoutedEventArgs e)
        {
            if(e.Key == Windows.System.VirtualKey.Enter)
            {
                opacityButton_Click(null, null);
            }
        }

        #endregion
        #region  ư Ŭ óϱ - opacityButton_Click(sender, e)

        /// <summary>
        ///  ư Ŭ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void opacityButton_Click(object sender, RoutedEventArgs e)
        {
            if(!ApiInformation.IsApiContractPresent("Windows.Foundation.UniversalApiContract", 7))
            {
                return;
            }

            float opacity = NormalizeValue(this.opacityNumberBox);

            this.rectangle.Opacity = opacity;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////// Function

        #region  ȭϱ - NormalizeValue(numberBox)

        /// <summary>
        ///  ȭϱ
        /// </summary>
        /// <param name="numberBox">ѹ ڽ</param>
        /// <returns></returns>
        private float NormalizeValue(NumberBox numberBox)
        {
            if(double.IsNaN(numberBox.Value))
            {
                numberBox.Value = 0;
            }

            return (float)numberBox.Value;
        }

        #endregion
    }
}